Bug 59824 - Casting an array of enums is inconsistent with .NET Framework behavior
Summary: Casting an array of enums is inconsistent with .NET Framework behavior
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: General (show other bugs)
Version: unspecified
Hardware: PC Mac OS
: --- normal
Target Milestone: ---
Assignee: Rodrigo Kumpera
URL:
Depends on:
Blocks:
 
Reported: 2017-09-28 16:03 UTC by Bertrand Le Roy
Modified: 2017-09-29 23:23 UTC (History)
3 users (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description Bertrand Le Roy 2017-09-28 16:03:35 UTC
Casting a `SomeEnumType[]` to `IReadOnlyList<int>` works on .NET Framework, but throws invalid cast exception on the mac.

Here's a sample repro:

```csharp
using System;
using System.Collections.Generic;

enum Foo { a, b };

class Program {
    static void Main() {
        var x = new Foo[10];
        var y = (IReadOnlyList<int>)(object)x;
    }
}
```
Comment 1 Rodrigo Kumpera 2017-09-28 20:53:44 UTC
https://github.com/mono/mono/pull/5659
Comment 2 Rodrigo Kumpera 2017-09-29 23:23:31 UTC
Fixed in master.

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.